﻿namespace AddisonWesley.Michaelis.EssentialCSharp.Chapter05.Listing05_32
{
    using System;
    using System.IO;

    public class Program
    {
        public static void Main()
        {
            System.Console.WriteLine("Bez danych wyjściowych");
        }
    }

    class Employee
    {
        public Employee(string firstName, string lastName)
        {
            int id;
            // Generowanie identyfikatora pracownika
            id = 0; // Zmienna id wymaga w tym przykładzie zainicjowania
            // ...
            Initialize(id, firstName, lastName);
        }

        public Employee(int id, string firstName, string lastName)
        {
            Initialize(id, firstName, lastName);
        }

        public Employee(int id)
        {
            string firstName;
            string lastName;
            Id = id;

            firstName = string.Empty;
            lastName = string.Empty;
            // ...

            Initialize(id, firstName, lastName);
        }

        private void Initialize(
            int id, string firstName, string lastName)
        {
            Id = id;
            FirstName = firstName;
            LastName = lastName;
        }
        // ...


        public int Id { get; private set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string Salary { get; set; } = "Za niskie";
        public string Title { get; set; }
        public Employee Manager { get; set; }

        // Właściwość Name
        public string Name
        {
            get
            {
                return FirstName + " " + LastName;
            }
            set
            {
                // Rozbijanie przypisanej wartości na imię i nazwisko.
                string[] names;
                names = value.Split(new char[] { ' ' });
                if(names.Length == 2)
                {
                    FirstName = names[0];
                    LastName = names[1];
                }
                else
                {
                    // Zgłaszanie wyjątku, jeśli nie przypisano
                    // imienia i nazwiska.
                    throw new System.ArgumentException(
                        $"Przypisana wartość '{value}' jest nieprawidłowa");
                }
            }
        }
    }
}
