﻿namespace AddisonWesley.Michaelis.EssentialCSharp.Chapter11.Listing11_21
{
    using System;
    using Listing11_13;

    public class BinaryTree<T>
    {
        public T Item { get; set; }
        public Pair<BinaryTree<T>> SubItems
        {
            get { return _SubItems; }
            set
            {
                IComparable<T> first;
                first = (IComparable<T>)value.First.Item;

                if(first.CompareTo(value.Second.Item) < 0)
                {
                    // Wartość właściwości First jest mniejsza niż właściwości Second.
                    // ...
                }
                else
                {
                    // Wartości właściwości First i Second są takie same
                    // lub wartość właściwości Second jest mniejsza.
                    // ...
                }
                _SubItems = value;
            }
        }
        private Pair<BinaryTree<T>> _SubItems;
    }
}